<template>
  <div id="dataPublicationSummary">
    <!-- General Description -->
    <p class="mb-3">
      {{ $t("page.dataPublicationSummary.description") }}
    </p>

    <!-- Fields from DataPublicationProjectData -->
    <CoscineFormGroup
      :label="$t('page.dataPublicationForm.labels.requesterNameLabel')"
    >
      <b-form-input
        readonly
        :disabled="true"
        :model-value="user ? user.displayName : ''"
      />
    </CoscineFormGroup>
    <CoscineFormGroup :label="$t('page.dataPublicationForm.labels.emailLabel')">
      <b-form-input
        readonly
        :disabled="true"
        :model-value="user?.emails ? user.emails.at(0)?.email : ''"
      />
    </CoscineFormGroup>
    <CoscineFormGroup
      :label="$t('page.dataPublicationForm.labels.projectNameLabel')"
    >
      <b-form-input
        readonly
        :disabled="true"
        :model-value="project ? project.name : ''"
      />
    </CoscineFormGroup>
    <CoscineFormGroup :label="$t('page.dataPublicationForm.labels.pidLabel')">
      <b-form-input
        readonly
        :disabled="true"
        :model-value="project ? project.pid : ''"
      />
    </CoscineFormGroup>
    <CoscineFormGroup
      :label="$t('page.dataPublicationForm.labels.disciplineLabel')"
    >
      <multiselect
        id="discipline"
        v-model="disciplines"
        :disabled="true"
        :options="disciplines"
        :multiple="true"
        :hide-selected="false"
        :label="disciplineLabel"
        :track-by="disciplineLabel"
        :placeholder="$t('form.project.projectDiscipline')"
        :show-labels="false"
      >
        <template #option="entities">
          <div :disabled="true">
            {{ entities.option[disciplineLabel] }}
          </div>
        </template>
      </multiselect>
    </CoscineFormGroup>
    <CoscineFormGroup
      :label="$t('page.dataPublicationForm.labels.resourceLabel')"
    >
      <multiselect
        id="resources"
        :model-value="selectedResources"
        :options="resources"
        :disabled="true"
        label="displayName"
        track-by="id"
        :hide-selected="false"
        :multiple="true"
        :placeholder="$t('page.dataPublicationForm.resource')"
      >
        <template #popover>
          {{ $t("page.dataPublicationForm.resourceLabelPopover") }}
        </template>
      </multiselect>
    </CoscineFormGroup>
    <CoscineFormGroup
      :label="$t('page.dataPublicationForm.labels.messageLabel')"
    >
      <b-form-textarea id="message" v-model="localMessage" :disabled="true" />
    </CoscineFormGroup>

    <!-- Buttons -->
    <b-form-group>
      <!-- Back Button -->
      <b-button variant="primary" @click.prevent="back">
        {{ $t("buttons.back") }}
      </b-button>

      <!-- Continue Button -->
      <b-button variant="primary" class="float-right" @click.prevent="submit">
        {{ $t("buttons.submit") }}
      </b-button>
    </b-form-group>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useProjectStore from "@/modules/project/store";
import useUserStore from "@/modules/user/store";
import useNotificationStore from "@/store/notification";
import type {
  UserDto,
  ResourceDto,
  DisciplineDto,
  ProjectDto,
  PublicationRequestForCreationDto,
  OrganizationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import { navigateToProject } from "@/router";

export default defineComponent({
  props: {
    modelValue: {
      type: Object as PropType<PublicationRequestForCreationDto>,
      required: true,
    },
  },
  emits: {
    valid: (_: boolean) => true,
    "update:modelValue": (_: PublicationRequestForCreationDto) => true,
    "update:message": (_: string | null | undefined) => true,
    back: null,
  },
  setup() {
    const projectStore = useProjectStore();
    const userStore = useUserStore();
    const notificationStore = useNotificationStore();

    return { projectStore, userStore, notificationStore };
  },

  data() {
    return {
      localMessage: this.modelValue.message,
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    resources(): ResourceDto[] {
      if (this.projectStore?.currentResources) {
        return this.projectStore?.currentResources
          .map((resource) => ({
            displayName: resource.displayName,
            id: resource.id,
          })) // Extract resource display name, could contain empty strings
          .filter((n) => n); // Filter out empty strings, if any;
      }
      return [];
    },
    selectedResources(): ResourceDto[] {
      const currentResources = this.projectStore?.currentResources;
      const selected = this.modelValue.resourceIds;

      return (
        currentResources?.filter((r) => selected.some((s) => s === r.id)) ??
        ([] as ResourceDto[])
      );
    },
    selectedPublicationService(): OrganizationDto | undefined {
      const currentServices = this.projectStore?.publicationAdvisoryServices;
      const selected = this.modelValue.publicationServiceRorId;

      return currentServices?.find((r) => selected === r.uri);
    },
    user(): UserDto | null | undefined {
      return this.userStore.user;
    },
    disciplines(): DisciplineDto[] {
      return this.project?.disciplines ?? [];
    },
    disciplineLabel(): string {
      let locale = this.$i18n.locale;
      // Ensure that the value of locale is a valid locale, otherwie the property for disciplineLabel will be inaccurate
      if (this.$i18n.availableLocales.includes(locale) === false) {
        locale = this.$i18n.fallbackLocale.toString();
      }
      locale = locale.charAt(0).toUpperCase() + locale.slice(1);
      return `displayName${locale}`;
    },
  },
  watch: {
    publicationRequestForCreation: {
      handler() {
        this.$emit("update:modelValue", this.modelValue);
      },
      deep: true,
    },
    message(newMessage) {
      this.localMessage = newMessage;
    },
    localMessage() {
      this.updateMessage();
    },
  },
  methods: {
    back() {
      this.$emit("back");
    },
    updateMessage() {
      this.$emit("update:message", this.localMessage);
    },

    async submit() {
      if (this.project) {
        const createdPublicationRequest =
          await this.projectStore.createPublicationRequest(
            this.project,
            this.modelValue,
          );

        if (createdPublicationRequest) {
          this.notificationStore.postNotification({
            title: this.$t("page.dataPublicationSummary.toastTitle").toString(),
            body: this.$t("page.dataPublicationSummary.toastBody"),
          });
          // Navigate inside the parent project
          navigateToProject(this.project);
        } else {
          // On Failure
          this.notificationStore.postNotification({
            title: this.$t("toast.onSave.failure.title").toString(),
            body: this.$t("toast.onSave.failure.message").toString(),
            variant: "danger",
          });
        }
      }
    },
  },
});
</script>
